Skip to content
Start here

Write multiple key-value pairs

client.KV.Namespaces.BulkUpdate(ctx, namespaceID, params) (*NamespaceBulkUpdateResponse, error)
PUT/accounts/{account_id}/storage/kv/namespaces/{namespace_id}/bulk

Writes up to 10,000 key-value pairs to the specified Workers KV namespace from a JSON array, with optional metadata and expiration settings for each pair. Existing values and expirations are overwritten. If neither expiration nor expiration_ttl is specified, the key-value pair will not expire. If both are set, expiration_ttl takes precedence. The entire request must be 100 megabytes or less. The result reports the number of successful writes and any keys that failed and should be retried.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Workers KV Storage Write
ParametersExpand Collapse
namespaceID string

ID of the Workers KV namespace.

maxLength32
params NamespaceBulkUpdateParams
AccountID param.Field[string]

Path param: ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32
Body param.Field[[]NamespaceBulkUpdateParamsBody]

Body param

Key string

A key’s name. The name may be at most 512 bytes. All printable, non-whitespace characters are valid.

maxLength512
Value string

A UTF-8 encoded string to be stored, up to 25 MiB in length.

maxLength26214400
Base64 boolOptional

Indicates whether or not the server should base64 decode the value before storing it. Useful for writing values that wouldn’t otherwise be valid JSON strings, such as images.

Expiration float64Optional

Expires the key at a certain time, measured in number of seconds since the UNIX epoch.

ExpirationTTL float64Optional

Number of seconds until the key expires. Must be at least 60. Takes precedence over expiration when both are specified.

minimum60
Metadata unknownOptional

Arbitrary JSON that is associated with a key.

ReturnsExpand Collapse
type NamespaceBulkUpdateResponse struct{…}
SuccessfulKeyCount float64Optional

Number of keys successfully written or deleted by the bulk operation.

UnsuccessfulKeys []stringOptional

Names of keys that failed to be written or deleted. Retry the operation for these keys.

Write multiple key-value pairs

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/kv"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.KV.Namespaces.BulkUpdate(
    context.TODO(),
    "0f2ac74b498b48028cb68387c421e279",
    kv.NamespaceBulkUpdateParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
      Body: []kv.NamespaceBulkUpdateParamsBody{kv.NamespaceBulkUpdateParamsBody{
        Key: cloudflare.F("My-Key"),
        Value: cloudflare.F("Some string"),
      }},
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.SuccessfulKeyCount)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "successful_key_count": 100,
    "unsuccessful_keys": [
      "string"
    ]
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "successful_key_count": 100,
    "unsuccessful_keys": [
      "string"
    ]
  }
}